void Go(int distance)
{
  float fudge;
  fudge = 1.0;
  
  lcount=0;                                        // reset left wheel encoder counter
  rcount=0;                                        // reset right wheel encoder counter
  
  Stop();
  delay(100);
  volts=analogRead(Battery)/10;
  dspeed=26214/volts*10/volts;                     // draw speed power correction factor=100% when battery=5V (analog reading = 512)
  dspeed=dspeed*8/10;                              // adjust speed to reduce overshoot
  
  if(distance>0)                                   // distance values>0 tell the robot to go forward
  {
    lspeed=(dspeed);
    rspeed=(dspeed);
  }
  else                                             // distance values less than 0 tell the robot to go backward
  {
    lspeed=(-dspeed);
    rspeed=(-dspeed);
  }
  distance=abs(distance);                          // distance only - ignore direction
  if(turn==0) distance*=charsize;
  
  int ols=lspeed;
  int ors=rspeed;
  
  if (FirstStep < 3)
    {
     starttime = millis();
     while(lcount<distance || rcount<distance)        // travel until both wheel encoders count correct distance
      {
      lspeed=ols;
      rspeed=ors;
      Motors();
      }
    duration = millis()-starttime;
    if (FirstStep = 1)                                //lengthy process of determining cal numberts
    { 
     leftfwdspeed = lcount/duration *1000;
     rightfwdspeed = rcount/duration * 1000;  
     if (leftfwdspeed > rightfwdspeed)
      {  
      lmotorfixfwd =abs(rightfwdspeed/leftfwdspeed)*fudge;
      rmotorfixfwd = 1;
      }
     else
       {
      rmotorfixfwd = abs(leftfwdspeed/rightfwdspeed)*fudge;
      lmotorfixfwd = 1;
        }
    }
    
    if (FirstStep = 2)
    {
     leftrevspeed = lcount/duration * 1000;
     rightrevspeed = rcount/duration * 1000;
     
      if (leftrevspeed > rightrevspeed)
       {  
       lmotorfixrev= abs(rightrevspeed/leftrevspeed)*fudge;
       rmotorfixrev = 1;
       }
      else
       {
       rmotorfixrev = abs(leftrevspeed/rightrevspeed)*fudge;
       lmotorfixrev = 1;
       }
      if (abs(leftrevspeed) > abs(rightfwdspeed))
       {
        lmotorfixleftturn = abs(rightfwdspeed/leftrevspeed)*fudge;
        rmotorfixleftturn = 1;
       }
       else
         {
          rmotorfixleftturn = abs(leftrevspeed/rightfwdspeed)*fudge;
          lmotorfixleftturn = 1;
         }
     if (abs(leftfwdspeed) > abs(rightrevspeed))
       {
         lmotorfixrightturn = abs(rightrevspeed/leftfwdspeed)*fudge;
         rmotorfixrightturn = 1;
       }
      else
        {
         rmotorfixrightturn = abs(leftfwdspeed/rightrevspeed)*fudge;
         lmotorfixrightturn = 1;
        }
    }
    } 
    
  else
  {    
  while(lcount<distance || rcount<distance)        // travel until both wheel encoders count correct distance
  {
    if(lcount>rcount)
    {
 //   lspeed= 0;
    }
    else
    {
    lspeed=ols;
    }
    if(rcount>lcount)
    {
 //    rspeed = 0;
    }
    else
    {
    rspeed=ors;
    }
    Motors();
  }
  }

  Stop();

  // ensure both motors are completely stopped
}
